/*
Copyright 2020 The KEDA Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/kedacore/keda/v2/api/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// ClusterTriggerAuthenticationLister helps list ClusterTriggerAuthentications.
// All objects returned here must be treated as read-only.
type ClusterTriggerAuthenticationLister interface {
	// List lists all ClusterTriggerAuthentications in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.ClusterTriggerAuthentication, err error)
	// Get retrieves the ClusterTriggerAuthentication from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.ClusterTriggerAuthentication, error)
	ClusterTriggerAuthenticationListerExpansion
}

// clusterTriggerAuthenticationLister implements the ClusterTriggerAuthenticationLister interface.
type clusterTriggerAuthenticationLister struct {
	indexer cache.Indexer
}

// NewClusterTriggerAuthenticationLister returns a new ClusterTriggerAuthenticationLister.
func NewClusterTriggerAuthenticationLister(indexer cache.Indexer) ClusterTriggerAuthenticationLister {
	return &clusterTriggerAuthenticationLister{indexer: indexer}
}

// List lists all ClusterTriggerAuthentications in the indexer.
func (s *clusterTriggerAuthenticationLister) List(selector labels.Selector) (ret []*v1alpha1.ClusterTriggerAuthentication, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.ClusterTriggerAuthentication))
	})
	return ret, err
}

// Get retrieves the ClusterTriggerAuthentication from the index for a given name.
func (s *clusterTriggerAuthenticationLister) Get(name string) (*v1alpha1.ClusterTriggerAuthentication, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("clustertriggerauthentication"), name)
	}
	return obj.(*v1alpha1.ClusterTriggerAuthentication), nil
}
